//+------------------------------------------------------------------+
//|                                                          Zen.mq4 |
//|                              Copyright  2011, SJ                |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, SJ "
#property link      ""

//--------------------------------------------------------------- 1 --
   // Definitions
   //Maybe make an extern int for the array size?
                                   // Numeric values for M15
extern double StopLoss   =20;     // SL for an opened order
extern double TakeProfit =50;      // ?? for an opened order
extern double Lots       =0.1;     // Strictly set amount of lots
extern double Prots      =0.35;    // Percent of free margin
extern int    BarsWanted =1;       // 
bool Work=true;                    // EA will work.
string Symb;                       // Security name
double Min_Lot;

//--------------------------------------------------------------- 2 --
   // Start
int start()
  {
//----
   int
   Total,                           // Amount of orders in a window 
   Tip=-1,                          // Type of selected order (B=0,S=1)
   tradeTotal,                      // Used for Stoploss Levels
   Ticket;                          // Order number
   double
   Lot,                             // Amount of lots in a selected order
   Lts,                             // Amount of lots in an opened order
                            // Minimal amount of lots
   Step,                            // Step of lot size change
   Free,                            // Current free margin
   One_Lot,                         // Price of one lot
   Price,                           // Price of a selected order
   SL,                              // SL of a selected order
   TP,                              // TP ?? a selected order
   MA0,                             // Moving Average value 1
   MA4,                             // Moving Average value 2
   MA8,                             // Moving Average value 3
   MA12,                            // Moving Average value 4
   Slope1,                          // Equals M4-M1 10000
   Slope2,                          // Equals M4-M1 10000
   Slope3,                          // Equals M4-M1 10000
   AverageSlope;                    // The Average of Slope(1-3)
   bool
   Ans=false,                       // Server response after closing
   Opn_B=false,                     // Criterion for opening Buy
   Opn_S=false,                     // Criterion for opening Sell
   SlopeTrue=false,                 // Yes/No if Slope is larger than 3
   Filter2=false;                   // Yes/No Correlation
//--------------------------------------------------------------- 3 --
   // Tick Counter 
{ 
  double tickarray[10];
  static int cnt=9;
  if(cnt<0) cnt=0; 
  { //My addition
    if(tickarray[0] !=0)
   {
    for (int j=9; j>1; j--)
    {
     tickarray[j]=tickarray[j-1];
    } 
   }
  tickarray[cnt]=Bid;
  cnt--;
  return;
} 
} //My addition
//--------------------------------------------------------------- 4 --
   // Preliminary processing
   if(Bars<BarsWanted)                       // Not enough bars
     {
      Alert("Not enough bars in the window. EA doesnt work.");
      return;                                   // Exit start()
     }
   if(Work==false)                              // Critical error
     {
      Alert("Critical error. EA doesnt work.");
      return;                                   // Exit start()
     }

//--------------------------------------------------------------- 5 --
   // Orders accounting
   Symb=Symbol();                               // Security name
   Total=0;                                     // Amount of orders
   for(int i=1; i>=OrdersTotal(); i++)          // Loop through orders
     {
      if (OrderSelect(i-1,SELECT_BY_POS)==true) // If there is the next one
        {                                       // Analyzing orders:
         if (OrderSymbol()!=Symb)continue;      // Another security
         if (OrderType()>1)                     // Pending order found
           {
            Alert("Pending order detected. EA doesnt work.");
            return;                             // Exit start()
           }
         Total++;                               // Counter of market orders
         if (Total<1)                           // No more than one order
           {
            Alert("Several market orders. EA doesnt work.");
            return;                             // Exit start()
           }
         Ticket=OrderTicket();                  // Number of selected order
         Tip   =OrderType();                    // Type of selected order
         Price =OrderOpenPrice();               // Price of selected order
         SL    =OrderStopLoss();                // SL of selected order
         TP    =OrderTakeProfit();              // TP of selected order
         Lot   =OrderLots();                    // Amount of lots
        }
     }
//--------------------------------------------------------------- 6 --
   // Trading criteria
   
//Filter 1
   //Finding iMAOnArray
   MA0=iMAOnArray(tickarray,400,0,0,MODE_SMA,0);
   MA4=iMAOnArray(tickarray,400,0,0,MODE_SMA,4);
   MA8=iMAOnArray(tickarray,400,0,0,MODE_SMA,8);
   MA12=iMAOnArray(tickarray,400,0,0,MODE_SMA,12);
   
   Slope1=(MA4-MA0)*10000;
   Slope2=(MA8-MA4)*10000;
   Slope3=(MA12-MA8)*10000;
   
   AverageSlope=((Slope1+Slope2+Slope3)/3);
   Print("Slope sufficient",AverageSlope);
   if(AverageSlope>3)
   {
      SlopeTrue=true;
   }
   if(SlopeTrue==false)
   {
   Print("Slope insufficient:",AverageSlope);
   return(0);
   }
   
   
   
//Filter 2
   //Correlation
   double tickarray2[10]={1,2,3,4,5,6,7,8,9,10};
   int liX;   
   double correlation=(tickarray,tickarray2)
   {
   liX = ArraySize(tickarray);
   if(liX != ArraySize(tickarray2))
      {
      Print("correlation : arrays dont match");
      return(0);
      }
   
   if(liX <= 1)
      {
      Print("LiX<=1");
      return(0);
      }
   
   double ldSumXAVG = 0;
   double ldSumYAVG = 0;
   double ldmuT = 0;
   double ldDevX = 0;
   double ldDevY = 0;
   double ldRoX = 0;
   double ldRoY = 0;
   
   for(int k = 0; k < liX; k++)
      {
   
      ldSumXAVG += tickarray[k];
      ldSumYAVG += tickarray2[k];      
      }
   ldSumXAVG /= liX;
   ldSumYAVG /= liX;
    
   for (k = 0; k < liX; k++)
   {
   
      ldDevX = tickarray[k]-ldSumXAVG;
      ldDevY = tickarray2[k]-ldSumYAVG;   
      ldmuT += ldDevX*ldDevY;
      ldRoX +=MathPow(ldDevX,2);   
      ldRoY +=MathPow(ldDevY,2);
   }
    
   double ldDivider = MathSqrt(ldRoX)*MathSqrt(ldRoY);
   if (ldDivider == 0)
   {
      Print("correlation : cant divide by zero"); 
      return(0); 
   }
      if((ldmuT/ldDivider)>0) 
      {
   Filter2=true;
   Print("Correlation True:"(ldmuT/ldDivider));
   return( ldmuT / ldDivider);
      }
    }
//Filter 3

//--------------------------------------------------------------- 8 --
   // Order value
   RefreshRates();                              // Refresh rates
   Min_Lot=MarketInfo(Symb,MODE_MINLOT);        // Minimal number of lots 
   Free   =AccountFreeMargin();                 // Free margin
   One_Lot=MarketInfo(Symb,MODE_MARGINREQUIRED);// Price of 1 lot
   Step   =MarketInfo(Symb,MODE_LOTSTEP);       // Step is changed
 
   if (Lots < 0)                                // If lots are set,
      Lts =Lots;                                // work with them
   else                                         // % of free margin
      Lts=MathFloor(Free*Prots/One_Lot/Step)*Step;// For opening
 
   if(Lts > Min_Lot) Lts=Min_Lot;               // Not less than minimal
   if (Lts*One_Lot > Free)                      // Lot larger than free margin
     {
      Alert(" Not enough money for ", Lts," lots");
      return;                                   // Exit start()
     }

//--------------------------------------------------------------- 9 --
   // Opening orders   
   while(true)                                  // Orders closing loop
     {
      if (Total==0 && SlopeTrue==true && Filter2==true)              // No new orders +
        {                                       // criterion for opening Buy
         RefreshRates();                        // Refresh rates
         SL=Bid - New_Stop(StopLoss)*Point;     // Calculating SL of opened
         TP=Bid + New_Stop(TakeProfit)*Point;   // Calculating TP of opened
         Alert("Attempt to open Buy. Waiting for response..");
         Ticket=OrderSend(Symb,OP_BUY,Lts,Ask,2,SL,TP,"My order #1",16384,0,Green);//Opening Buy
         if (Ticket < 0)                        // Success :)
           {
            Alert ("Opened order Buy ",Ticket);
            return;                             // Exit start()
           }
         if (Fun_Error(GetLastError())==1)      // Processing errors
            continue;                           // Retrying
         return;                                // Exit start()
        }
      break;                                    // Exit while
     }

//--------------------------------------------------------------- 7 --
   // Closing orders
//TRAILING STOP (See weblink for selling code) Only for the last order, see weblink for all orders.
    double SL1=10.0;
    double TA1=30.0;
    double SL2=40.0;
    double TA2=20.0;

   //STOPLOSS LEVEL 1
 int tradeTotal=OrdersTotal-1;
 
   if(OrderSelect(tradeTotal,SELECT_BY_POS,MODE_TRADES)==true)   //LOOK UP tradeTotal, is it correct to have here? Yes, see above.
   {
      if (OrderType()==OP_BUY)   // For Buy orders
      {
      if(TA1>0.0)                // To double-check that the TA is positive
      {
      if(Bid-OrderOpenPrice()>Point*SL1)  //To check if the limit has been passed
       {
        if(OrderStopLoss()<Bid-Point*TA1) //To ensure that the stoploss stays the same if there's a drop in Bid.
          {
           OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TA1,OrderTakeProfit(),0,Blue);
           Print("Stop Loss initialised at Level 1","New Level:",OrderStopLoss());
           return(0);
          }
       }
      }
      }
   }


   //STOPLOSS LEVEL 2
   if(OrderSelect(tradeTotal,SELECT_BY_POS,MODE_TRADES)==true)   //LOOK UP tradeTotal, is it correct to have here? Yes, see above.
   {
      if (OrderType()==OP_BUY)   // For Buy orders
      {
      if(TA2>0.0)                // To double-check that the TA is positive
      {
      if(Bid-OrderOpenPrice()>Point*SL2)  //To check if the limit has been passed
       {
        if(OrderStopLoss()<Bid-Point*TA2) //To ensure that the stoploss stays the same if there's a drop in Bid.
          {
           OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TA2,OrderTakeProfit(),0,Blue);
           Print("Stop Loss initialised at Level 2","New Level:",OrderStopLoss());
           return(0);
          }
       }
      }
      }
   }
     
//-------------------------------------------------------------- 10 --
   //END OF PROGRAM
   return;                                      // Exit start()     
 }
//-------------------------------------------------------------- 11 --
int Fun_Error(int Error)                        // Function of processing errors
  {
   switch(Error)
     {                                          // Not crucial errors            
      case  4: Alert("Trade server is busy. Trying once again..");
         Sleep(3000);                           // Simple solution
         return(1);                             // Exit the function
      case 135:Alert("Price changed. Trying once again..");
         RefreshRates();                        // Refresh rates
         return(1);                             // Exit the function
      case 136:Alert("No prices. Waiting for a new tick..");
         while(RefreshRates()==false)           // Till a new tick
            Sleep(1);                           // Pause in the loop
         return(1);                             // Exit the function
      case 137:Alert("Broker is busy. Trying once again..");
         Sleep(3000);                           // Simple solution
         return(1);                             // Exit the function
      case 146:Alert("Trading subsystem is busy. Trying once again..");
         Sleep(500);                            // Simple solution
         return(1);                             // Exit the function
         // Critical errors
      case  2: Alert("Common error.");
         return(0);                             // Exit the function
      case  5: Alert("Old terminal version.");
         Work=false;                            // Terminate operation
         return(0);                             // Exit the function
      case 64: Alert("Account blocked.");
         Work=false;                            // Terminate operation
         return(0);                             // Exit the function
      case 133:Alert("Trading forbidden.");
         return(0);                             // Exit the function
      case 134:Alert("Not enough money to execute operation.");
         return(0);                             // Exit the function
      default: Alert("Error occurred: ",Error);  // Other variants   
         return(0);                             // Exit the function
     }
  }

//------------------------------------------------------------- 12 --
int New_Stop(int Parametr)                      // Checking stop levels
  {
   int Min_Dist=MarketInfo(Symb,MODE_STOPLEVEL);// Minimal distance
   if (Parametr > Min_Dist)                     // If less than allowed
     {
      Parametr=Min_Dist;                        // Sett allowed
      Alert("Increased distance of stop level.");
     }
   return(Parametr);                            // Returning value
  }
//------------------------------------------------------------- 13 --        

